/*************************************************************************
 * Subway Plus
 *
 * (c) 2000, 2002
 *
 * Subway: Kim Dongjin (sysams@wow1.hongik.ac.kr)
 * Subway PLUS: Choi Seunggi (smallpig@unitel.co.kr)
 * Daten Seoul: Pak Hungsik (dr_mac@hanmail.net)
 * Deutsche Version + Karte: Thomas Mueller (tom@cellvic.de)
 *
 */
#include "cvos.h"
#include "appinfo.h" 
#include "..\resource\subway.h"
#include "..\image\subimage.h"
#include "define.h"

extern STATUS AppMain(U32 cmd, P_U32 param);

// About Box
U32	timerDboxId;
S8 	disCount;

void Dihelp(void); 
Boolean ApplicationHandleEvent(EventStruct * e);
Boolean HelloFormHandleEvent(EventStruct * e);


/*************************************************************************
 * DRAWLOCATION
 *
 * Anzeige des aktuellen Ausschnitts im Vergleich zur Gesamtkarte
 *
 * in:  -
 * out: -
 * ret: -
 *
 */
void DrawLocation(void)
{
    U8 x, y;

    ClearRec(WHITE, SM_STX + 1, SM_STY + 1, SM_WIDTH - 1, SM_HEIGHT - 1, 0);

    DrawRec(BLACK, SM_STX, SM_STY, SM_STX + SM_WIDTH, SM_STY + SM_HEIGHT, 0, 0);

    x = SM_STX + _SubOffX / ( SUBX / SM_WIDTH );
    y = SM_STY + _SubOffY / ( SUBY / SM_HEIGHT );

    if (x == SM_STX) 
        x = SM_STX + 1;
    if (y == SM_STY) 
        y = SM_STY + 1; 

    InvRec(x, y, SMW, SMH); 
}

/*************************************************************************
 * PUTSUBIMAGE
 *
 * Ausschnitt darstellen
 *
 * in:  -
 * out: -
 * ret: -
 *
 */
void PutSubImage(void)
{
    S16 i,j;

    S16 xb;
    S16 xsb;

    // U8 a[SUBXB];
    U8 *a;
    a = (U8 *)Lmalloc( (SUBWIDTH / 8) * SUBHEIGHT );

    xb =  SUBXB ; 
    xsb = _SubOffX / 8; 


    for( i=0 ; i < SUBHEIGHT ;  i++)
        {
        MoveBlock(&subway[xb * (_SubOffY + i ) + xsb], 
                  &a[ i * (SUBWIDTH / 8 )], SUBWIDTH / 8) ;
        }

    PutRec(a, SUBSTARTX, SUBSTARTY, SUBWIDTH, SUBHEIGHT, REPLACE_STYLE, 0);

    Lfree(a);
    DrawLocation();

    _IsHelpOn = FALSE;
}

/*************************************************************************
 * DIHELP
 *
 * Zeit im Hilfsfenster darstellen
 *
 * in:  -
 * out: -
 * ret: -
 *
 */
void Dihelp(void)
{
   char buff[20];

   U32 date;
   U16 year,month,day,hour,minute,second;

   DateTimeRead(&year,&month,&day,&hour,&minute,&second);

   PutRec (swin, 0, 69 ,SWINX, SWINY, REPLACE_STYLE, 0);
   SnPrintf(buff,20,"%02d:%02d:%02d",hour,minute,second);

   ComponentSetVisible(FormGetComponentPtr(Label_time_1009),TRUE);
   LabelSetLabel(FormGetComponentPtr(Label_time_1009),(unsigned char *)buff,TRUE);

}

/*************************************************************************
 * DRAWHELP
 *
 * Hilfe
 *
 * in:  -
 * out: -
 * ret: -
 *
 */
void DrawHelp(void)
{
    if (!_IsHelpOn)
        {
        Dihelp();
        _IsHelpOn = TRUE;
        }
    else
        {
        PutSubImage();
        }
}

/*************************************************************************
 * STARTDBOXTIMER
 *
 * Timer mit Timeout nach <rate> ms erzeugen
 *
 * in:  rate : Millisekunden
 * out: -
 * ret: -
 *
 */
void startDboxTimer(int rate)
{
    if (TimeoutId(&timerDboxId, (unsigned long)rate, (unsigned short)TRUE) == CVOS_OK)
        ;
}

/*************************************************************************
 * KILLDBOXTIMER
 *
 * Timer entfernen
 *
 * in:  -
 * out: -
 * ret: -
 *
 */
void killDboxTimer(void)
{	
    if (timerDboxId >= 0)
        {
        if (KillTimerId(timerDboxId) == CVOS_OK)
            ;
        timerDboxId =- 1;
        }
}

/*************************************************************************
 * ONDBOXTIMER
 *
 * in:  -
 * out: -
 * ret: -
 *
 */
void OnDboxTimer(void)
{
    char str[4];

    SnPrintf(str,4,"-%d-",disCount);
    FMDrawString(30,142,str);
    disCount--;

    if (disCount < 0)
        {
        killDboxTimer();
        EventPutDBoxCloseEvent();
        }
}

/*************************************************************************
 * ABOUTFORMHANDLEEVENT
 *
 * Event Handler
 *
 * in:  e : Event
 * out: -
 * ret: TRUE : erledigt
 *
 */
Boolean AboutFormHandleEvent(EventStruct * e) 
{
    Boolean handled = FALSE;	

    if ((e->EventType == COMPONENTSELECTEVENT && e->ObjectID == 1101) ||
        (e->EventType == BUTTONUPEVENT && e->ObjectID == ENTER_BTN))
        {
        killDboxTimer();
        EventPutDBoxCloseEvent();
        handled = TRUE;
        }
    else if (e->EventType == TIMEOUTEVENT)
        {
        if (e->EventData.TimeoutEvent.timerId == timerDboxId)
            {
            OnDboxTimer();
            handled = TRUE;
            }	    
        }
    else if (e->EventType == PENDOWNEVENT)
        killDboxTimer(); //handled = TRUE;

    return handled;
}

/*************************************************************************
 * BYTE2KBYTE
 *
 * rechnet Bytes in KBytes um
 *
 * in:  bytes : Anzahl
 * out: -
 * ret: KBytes
 *
 */
U32 Byte2Kbyte(U32 bytes)
{
    U32 tmp = (bytes*10)/1024;	
    U32 Kbytes = ((tmp % 10) >= 5) ? tmp/10+1 : tmp/10;

    return Kbytes;	
}

/*************************************************************************
 * DBOXCALLBACK
 *
 * About-Infos
 *
 * in:  -
 * out: -
 * ret: -
 *
 */
void DboxCallBack(void)
{
    APPINFO ainfo;
    U32 AppId = GetCurAppID();	
    U8  str[50];
    U32 _memSize = Byte2Kbyte(TotalDBSize() - TotalDBUsed());

    GetAppInfoWithAID(AppId, &ainfo);
    PutRec(ainfo.codeptr->pLargeIcon,18,50,20,20,REPLACE_STYLE,0);
    FMSetFont( ENG9BOLD_HANGUL );
    FMDrawString(52 , 50, "Subway PLUS");
    FMDrawString(52 , 61,ainfo.codeptr->pVersion);
    FMSetFont(ENG9LITE_HANGUL);
    SnPrintf(str, 50, "(%dKB size, Total %dKB Free)",
        Byte2Kbyte(ainfo.codeptr->CodeSize + ainfo.codeptr->RDBSize + 
            ainfo.codeptr->GlobalSize),
        _memSize);
    FMDrawString((160-FMGetStringWidth(str))/2, 76, str);
    startDboxTimer(1000);	
}

/*************************************************************************
 * ABOUTMYPROGRAM
 *
 * About-Infos
 *
 * in:  -
 * out: -
 * ret: -
 *
 */
void AboutMyProgram(void)
{
    disCount = 3;
    DBoxNew(1100);
    FormSetEventHandler(AboutFormHandleEvent);
    DBoxSetDrawCallback((DBoxDrawCallbackFuncPtr)DboxCallBack);
    DBoxDo(1100);

    FormFree();
}


/*************************************************************************
 * INITHELLO
 *
 * Intialisierung
 *
 * in:  -
 * out: -
 * ret: TRUE: alles OK
 *
 */
Boolean InitHello(void) 
{
    if (!GUIInit())
        return FALSE;

    ClearScreen(WHITE);

    _SubOffX = 200;
    _SubOffY = 200;
    _IsPenPressed = FALSE;
    _IsHelpOn = TRUE;
    SystemToolDisable(APPSKEY_BIT);

    if (!FormGo(Form_Hello_1000))
        return FALSE;

    return TRUE;
}

/*************************************************************************
 * DEINITHELLO
 *
 * Deinitialisierung
 *
 * in:  -
 * out: -
 * ret: TRUE : alles OK
 *
 */
Boolean DeinitHello(void) 
{
    SystemToolEnable(APPSKEY_BIT);
    return TRUE;
}


/*************************************************************************
 * HELLOFORMHANDLEEVENT
 *
 * Event Handler
 *
 * in:  e : Event
 * out: -
 * ret: TRUE : erledigt
 *
 */
Boolean HelloFormHandleEvent(EventStruct * e)
{
    Boolean handled = FALSE;

    U8 x, y; 
    S16 gx, gy;

    switch (e->EventType)
        {
        case COMPONENTSELECTEVENT:
            if (e->ObjectID == Button_Start_1002)
                { 
                DrawHelp();
                }
            handled = TRUE;
            break;

        case BUTTONDOWNEVENT :
            switch (e->ObjectID)
                {
                case UP_BTN :
                    _SubOffY -= YSTEP;
                    if (_SubOffY < 0)
                        _SubOffY = 0;
                    PutSubImage();
                    handled = TRUE;
                    break;

                case DOWN_BTN :
                    _SubOffY += YSTEP;
                    if (_SubOffY + SUBHEIGHT > SUBY)
                        _SubOffY = SUBY - SUBHEIGHT;
                    PutSubImage();
                    handled = TRUE;
                    break;

                case LEFT_BTN :
                    _SubOffX -= XSTEP;
                    if (_SubOffX < 0)
                        _SubOffX = 0;
                    PutSubImage();
                    handled = TRUE;
                    break;

                case RIGHT_BTN :
                    _SubOffX += YSTEP;
                    if (_SubOffX + SUBWIDTH > SUBX)
                        _SubOffX = SUBX - SUBWIDTH;
                    PutSubImage();
                    handled = TRUE;
                    break;
                }
            break;

        case MENUSELECTEVENT:
            if (e->ObjectID == MenuItem_HelloAbout_3006)
                AboutMyProgram();
            else if (e->ObjectID == MenuItem_HelloHelp_3005)
                {
                APPHELPMSG	ahm;

                ahm.pCaptionStr = (P_U8)HelloHelpCaption;
                ahm.SbjNum = HELLO_HELPSBJNUM;
                ahm.StartIdx = 0;
                ahm.pSbjStr = (P_U8 *)HelloSbjStr;
                ahm.pMsgStr = (P_U8 *)HelloMsgStr;

                ShowHelpMessage( (P_VOID)&ahm, APPLICATION_HELP);
                }

            handled = TRUE;
            break;

        case PENUPEVENT:
            x = e->EventData.PenEventData.X; 
            y = e->EventData.PenEventData.Y;

            if (x > SUBSTARTX && x < (SUBSTARTX + SUBWIDTH ) &&
                y > SUBSTARTY && y < ( SUBSTARTY + SUBHEIGHT))
                {
                gx = _PenOldX - x;
                gy = _PenOldY - y;

                _SubOffX += gx;
                _SubOffY += gy;

                if (_SubOffX < 0)
                    _SubOffX = 0;
                if (_SubOffY < 0)
                    _SubOffY = 0;
                if (_SubOffX + SUBWIDTH > SUBX)
                    _SubOffX = SUBX - SUBWIDTH;
                if (_SubOffY + SUBHEIGHT > SUBY)
                    _SubOffY = SUBY - SUBHEIGHT;

                PutSubImage();
                _IsPenPressed = FALSE;
                handled = TRUE;
                }


            break;

        case PENDOWNEVENT:
            x = e->EventData.PenEventData.X; 
            y = e->EventData.PenEventData.Y;

            if (x > SUBSTARTX && x < (SUBSTARTX + SUBWIDTH) &&
                y > SUBSTARTY && y < (SUBSTARTY + SUBHEIGHT))
                {
                _IsPenPressed = TRUE;
                _PenOldX = x;
                _PenOldY = y;
                handled = TRUE; 
                }

            if (x > SM_STX && x < (SM_STX + SM_WIDTH) &&
                y > SM_STY && y < (SM_STY + SM_HEIGHT))
                {
                _SubOffX = ( x - SM_STX ) * ( SUBX / SM_WIDTH );
                _SubOffY = ( y - SM_STY ) * ( SUBY / SM_HEIGHT );

                if (_SubOffX + SUBWIDTH > SUBX)
                    _SubOffX = SUBX - SUBWIDTH;
                if (_SubOffY + SUBHEIGHT > SUBY)
                    _SubOffY = SUBY - SUBHEIGHT;

                PutSubImage();
                handled = TRUE;	
                }

            break;

        case PENDRAGEVENT:
            x = e->EventData.PenEventData.X; 
            y = e->EventData.PenEventData.Y;

            if (x > SUBSTARTX && x < (SUBSTARTX + SUBWIDTH) &&
                y > SUBSTARTY && y < (SUBSTARTY + SUBHEIGHT))
                {
                gx = _PenOldX - x;
                gy =  _PenOldY - y;

                _SubOffX += gx;
                _SubOffY += gy;

                if (_SubOffX < 0)
                    _SubOffX = 0;
                if (_SubOffY < 0)
                    _SubOffY = 0;
                if (_SubOffX + SUBWIDTH > SUBX)
                    _SubOffX = SUBX - SUBWIDTH;
                if (_SubOffY + SUBHEIGHT > SUBY)
                    _SubOffY = SUBY - SUBHEIGHT;

                PutSubImage();

                _PenOldX = x;
                _PenOldY = y;

                _IsPenPressed = TRUE;
                handled = TRUE;
                }			

            if (x > SM_STX && x < (SM_STX + SM_WIDTH) &&
                y > SM_STY && y < (SM_STY + SM_HEIGHT))
                {
                _SubOffX = ( x - SM_STX ) * ( SUBX / SM_WIDTH );
                _SubOffY = ( y - SM_STY ) * ( SUBY / SM_HEIGHT );

                if (_SubOffX + SUBWIDTH > SUBX)
                    _SubOffX = SUBX - SUBWIDTH;
                if (_SubOffY + SUBHEIGHT > SUBY)
                    _SubOffY = SUBY - SUBHEIGHT;

                PutSubImage();
                handled = TRUE;	
                }

            break;

        }

    return handled;
}


/*************************************************************************
 * APPLICATIONHANDLEEVENT
 *
 * Event Handler
 *
 * in:  e : Event
 * out: -
 * ret: TRUE : alles OK
 *
 */
Boolean ApplicationHandleEvent(EventStruct * e) 
{
    U16  id;
    Boolean  handled = FALSE;


    if (e->EventType == FORMLOADEVENT) 
        {
        FormNew(id = e->ObjectID);

        switch(id) 
            {
            case Form_Hello_1000 :
                FormSetEventHandler(HelloFormHandleEvent);
                FormDraw();
                PutSubImage();
                handled = TRUE;
                break;
            }
        }
    else if(e->EventType == FORMUNLOADEVENT) 
        {
        FormFree();
        handled = TRUE;
        }

    return handled;
}

/*************************************************************************
 * COMMANDPROCESSING
 *
 * Pseudo-Handler
 *
 * in:  cmd : Kommando
 *      param : Kommando-Parameter
 * out: -
 * ret: Status
 *
 */
STATUS CommandProcessing(U32 cmd, P_U32 param)
{
    STATUS retVal = CVOS_NOTHING;

    switch (cmd)
        {
        case REQ_VIEWFINDDATA:
            break;
        case REQ_DBTABLENUM:
            break;
        case REQ_DBTABLENAME:
            break;
        case REQ_DBTABLENAMEFORIR:
            break;
        case REQ_GLOBALFIND:
            break;
        case REQ_MATCHSTR:
            break;
        case REQ_UNINSTALL:
            break;
        };

    return retVal;
}


/*************************************************************************
 * APPMAIN
 *
 * Main-Funktion
 *
 * in:  cmd : Kommando
 *      param : Kommando-Parameter
 * out: -
 * ret: Status
 *
 */
STATUS AppMain(U32 cmd, P_U32 param) 
{
    EventStruct	event;

    if (cmd != NORMAL_START)
        return ( CommandProcessing(cmd, param));

    if (!InitHello())
        {
        (void)MsgBoxDo( MK_ERROR, "Initialize Error", "Error occur in InitHello().", MSGBOX_OK );
        return CVOS_ERROR;
        }

    do 
        {	/* EventLoop - Listen Event */
        while (!EventGet(&event))
            /* NULL LOOP */ ;
        if(!SystemHandleEvent(&event))
            if(!MenuHandleEvent(&event))
                if(!ApplicationHandleEvent(&event))
                    FormDispatchEvent(&event);
        }
    while(event.EventType != APPSTOPEVENT);

    if (!DeinitHello())
        return CVOS_ERROR;

    return CVOS_OK;
}

